unit FormsSearchRes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FormsMain;

type
  TSearchForWhat = (sfwMother, sfwFather, sfwGrandma, sfwGrandpa, sfwSiblings,
    sfwCousins, sfwSvagr, sfwZet, sfwGrandchild, sfwAnt, sfwGrandAnt, sfwHusband);
  TfrmSearch = class(TForm)
    lsvRes: TListBox;
  private
    { Private declarations }
  public
    function Search(Kind: TSearchForWhat; Who: TPerson): TPersonList;
    procedure SeShow(Kind: TSearchForWhat; Who: TPerson);
  end;

var
  frmSearch: TfrmSearch;

implementation

{$R *.DFM}

{ TfrmSearch }

function TfrmSearch.Search(Kind: TSearchForWhat; Who: TPerson): TPersonList;
var
  I, J: Integer;
begin
  Screen.Cursor := crHourGlass;
  Result := nil;
  with frmPersonList do
  case Kind of
    sfwHusband: begin
      for I := 0 to frmPersonList.PersonCount - 1 do
        for J := 0 to frmPersonList.PersonCount - 1 do
          if ((Persons[J].father = Persons[I].id) and (Persons[J].mother = Who.id)) or
            ((Persons[J].mother = Persons[I].id) and (Persons[J].father = Who.id)) then
          begin
            SetLength(Result, Length(Result) + 1);
            Result[Length(Result) - 1] := Persons[I]; 
            Break;
          end;
    end;
  else
    raise Exception.Create('Nen9 jeste hotovo...');
  end;
  Screen.Cursor := crArrow;
end;

procedure TfrmSearch.SeShow(Kind: TSearchForWhat; Who: TPerson);
const
  Genders: array[Boolean] of string = ('Mu', 'ena');
var
  P: TPersonList;
  I: Integer;
begin
  P := Search(Kind, Who);
  lsvRes.Items.Clear;
  for I := 0 to Length(P) - 1 do
    lsvRes.Items.Add(Format('<%s> %s %s (%s)', [P[I].id, p[i].name, p[i].surname, Genders[p[i].gender <> 'M']]));
end;

end.
