unit FormsGetPersonInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmGetPersonInfo = class(TForm)
    edtName: TEdit;
    edtSurname: TEdit;
    lblName: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtBirthdate: TEdit;
    edtDeathdate: TEdit;
    cmbMother: TComboBox;
    cmbFather: TComboBox;
    btnOK: TButton;
    btnCancel: TButton;
    Label7: TLabel;
    edtID: TEdit;
    rdbMale: TRadioButton;
    rdbFemale: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGetPersonInfo: TfrmGetPersonInfo;

implementation

uses FormsMain;

{$R *.DFM}

procedure TfrmGetPersonInfo.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  // Vlozme vsechny osoby do cmbs
  for I := 0 to frmPersonList.PersonCount - 1 do
    with frmPersonList.Persons[I] do begin
      if gender <> 'Z' then
        cmbFather.Items.Add(Format('<%s> %s %s', [id, name, surname]));
      if gender <> 'M' then
        cmbMother.Items.Add(Format('<%s> %s %s', [id, name, surname]));
    end;

  cmbFather.Items.Add('<neznm>');
  cmbFather.ItemIndex := cmbFather.Items.Count - 1;
  cmbMother.Items.Add('<neznm>');
  cmbMother.ItemIndex := cmbMother.Items.Count - 1;
end;

procedure TfrmGetPersonInfo.btnOKClick(Sender: TObject);
begin
  try
    // zkontrolujme udaje
    if (frmPersonList.SearchI[edtID.Text] <> -1) or (edtID.Text = '') then
      raise Exception.Create('Kad osoba mus mt uniktn ID.');
  except
    ModalResult := mrNone;
    raise;
  end;
end;

end.
